package eu.clarin.cmdi.mdservice.action;

import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.StringReader;
import java.io.StringWriter;
import java.net.MalformedURLException;
import java.net.URISyntaxException;
import java.net.URL;
import java.util.HashMap;
import java.io.ByteArrayInputStream;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.transform.OutputKeys;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.InputSource;

import eu.clarin.cmdi.mdservice.model.Query;

/**
 
 */
public class Pz2ProxyAction extends GenericProxyAction {

	private static final long serialVersionUID = 1L;

	private String proxy_key = "pazpar2";
	
	private String command;
	private String query;
	private String sessionID;
	private String sort;
	private String block;
	
	public void setCommand(String command) {
		this.command = command;
	}
	public String getCommand() {
		return command;
	}
	public void setQuery(String query) {
		this.query = query;
	}
	public String getQuery() {
		return query;
	}
	public void setSessionID(String sessionID) {
		this.sessionID = sessionID;
	}
	public String getSessionID() {
		return sessionID;
	}

	public void setSort(String sort) {
		this.sort = sort;
	}
	public String getSort() {
		return sort;
	}
	public void setBlock(String block) {
		this.block = block;
	}
	public String getBlock() {
		return block;
	}
	//TODO cache after analysis
	@Override
	public String getCache() {
		return Cache.SKIP;
	}
	
	public String createURLParams(){
		String params = "?";
		if (!(command == null)){
			params = params + "command=" + command;
		}
		if (!(sessionID == null)){
			params = params + "&session=" + sessionID;
		}
		if (!(query == null)){
			params = params + "&query=" + query;
		}
		if (!(getStartItem() == null)){
			params = params + "&start=" + getStartItem();
		}
		if (!(getMaximumItems() == null)){
			params = params + "&num=" + getMaximumItems();
		}
		if (!(sort == null)){
			params = params + "&sort=" + sort;
			if (!(block == null)){
				params = params + ":" + block;
			}
		}
		
		return params;
	}
	@Override
	public String getBaseURI() {		
		String uri = getRepositoryPath();		
		return uri;
	}
	
	@Override
	public URL getTargetRequest() throws IOException {
        URL targetURL = null;		
			
		targetURL =new URL( getBaseURL(), createURLParams() );
		Admin.notifyUser("Pz2.targetURL:" + targetURL);
	    return targetURL;
	}
	
}